<?php
/**
 * This file sets up our post types. We have two post types. One for Variants and one for Variant Values
 * @package IT_Exchange_Variants_Addon
 * @since 1.0.0
*/

/**
 * Registers the Variants Post Type
 *
 * @since 1.0.0
 *
 * @return void
*/
function it_exchange_variants_addon_register_post_types() {
	// Variant Post Type Args
	$labels    = array(
		'name'          => __( 'Product Variants', 'it-l10n-exchange-addon-variants' ),
		'singular_name' => __( 'Product Variant', 'it-l10n-exchange-addon-variants' ),
		'edit_item'     => __( 'Edit Variant', 'it-l10n-exchange-addon-variants' ),
		'view_item'     => __( 'View Variant', 'it-l10n-exchange-addon-variants' ),
	);
	$args = array(
		'labels' => $labels,
		'description'  => __( 'An iThemes Exchange Post Type for storing Product Variants in the system', 'it-l10n-exchange-addon-variants' ),
		'public'       => false,
		'show_ui'      => false,
		'hierarchical' => false,
		'supports'     => array( 'title', 'custom-fields', ),
	);

	$args = apply_filters( 'it_exchange_variants_addon_variant_post_type_args', $args );

	// Register the variant post type
	register_post_type( 'it_exchange_variant', $args );

	// Preset Post Type Args
	$labels    = array(
		'name'          => __( 'Variant Presets', 'it-l10n-exchange-addon-variants' ),
		'singular_name' => __( 'Variant Preset', 'it-l10n-exchange-addon-variants' ),
		'edit_item'     => __( 'Edit Variant Preset', 'it-l10n-exchange-addon-variants' ),
		'view_item'     => __( 'View Variant Preset', 'it-l10n-exchange-addon-variants' ),
	);
	$args = array(
		'labels' => $labels,
		'description'  => __( 'An iThemes Exchange Post Type for storing Product Variant Preset options in the system', 'it-l10n-exchange-addon-variants' ),
		'public'       => false,
		'show_ui'      => false,
		'hierarchical' => true,
		'supports'     => array( 'title', 'custom-fields', ),
	);

	$args = apply_filters( 'it_exchange_variants_addon_variant_preset_post_type_args', $args );

	// Register the post type
	register_post_type( 'it_exng_varnt_preset', $args );
}
add_action( 'init', 'it_exchange_variants_addon_register_post_types' );
