<?php
/**
 * The default template part for the product variants
 * in the content-product template part's
 * select-variant element
 *
 * @since 1.0.0
 * @version 1.0.0
 * @package IT_Exchange
 *
 * WARNING: Do not edit this file directly. To use
 * this template in a theme, simply copy this file's
 * content to the exchange/content-product/elements
 * directory located in your theme.
*/
?>
<?php do_action( 'it_exchange_content_product_before_variant_element' ); ?>
<div class="it-variant-options it-variant-select-options">
	<?php do_action( 'it_exchange_content_product_begin_variant_element' ); ?>
	<div class="it-variant-title"><?php it_exchange( 'variant', 'title', 'format=text' ); ?></div>
	<select class="it-variant-select">
		<?php while ( it_exchange( 'variant', 'values' ) ) : ?>
			<?php $selected = it_exchange( 'variant-value', 'get-is-default' ) ? 'selected' : ''; ?>
			<option <?php esc_attr_e( $selected ); ?> value="<?php esc_attr_e( it_exchange( 'variant-value', 'get-id' ) ); ?>"><?php it_exchange( 'variant-value', 'title' ); ?></option>
		<?php endwhile; ?>
	</select>
	<?php it_exchange_add_hidden_variant_field(); // Do not remove this or variants will not work ?>
	<?php do_action( 'it_exchange_content_product_end_variant_element' ); ?>
</div>
<?php do_action( 'it_exchange_content_product_after_variant_element' ); ?>
